local Zifnabs_Buffmon = {}
_G.Zifnabs_Buffmon = Zifnabs_Buffmon

local default_settings={
	["fpsmon"]={["active"]=true,["red"]=9,["yellow"]=16,["green"]=25},
	["buffmon"]={["active"]=true,["time"]=15,["hud"]=true,["sound"]="dingdong.mp3"},
	["hpmon"]={["active"]=true,["percent"]=35,["hud"]=true,["sound"]="aaaah.mp3"},
	["petcraft"]={["active"]=true,["hud"]=true,["sound"]="remind.mp3"},
}
local settings={}

local fps_frame=nil
local fps_info=nil
local hpmon={["last_alarm"]=0,["last_hp"]=0}
local monitored_buff={}

Zifnabs:plugin("Zifnabs_Buffmon",Zifnabs_Buffmon,true)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_Buffmon_OnLoad(this) this:RegisterEvent("PET_CRAFT_END") end
function Zifnabs_Buffmon_OnEvent(this,event) Zifnabs_Buffmon:OnEvent(event) end
function Zifnabs_Buffmon:OnEvent(event)
	if event=="VARIABLES_LOADED" then
		fps_frame=getglobal("Zifnabs_FPS")
		fps_info=getglobal("Zifnabs_FPS_Info_Text")
		Zifnabs_Buffmon:reload_settings()
		Zifnabs:dofile("Zifnabs_Config_Buffmon")
	elseif event=="SAVE_VARIABLES" then
		Zifnabs:save_settings(default_settings,settings)
	elseif event=="PET_CRAFT_END" and settings.petcraft.active==true then
		Zifnabs:hud(settings.petcraft,Zifnabs.LANG.Buffmon_PET_END)
	end
end

-- ******************************************************************************************
-- * ON UPDATE / TIMER
-- ******************************************************************************************

function Zifnabs_Buffmon:OnUpdate(elapsed,last,updates,timer)
	if settings.fpsmon.active then
		if last>=1 then
			local fps=math.floor(updates/last)
			fps_info:SetText(fps)
			local red=settings.fpsmon.red
			local yellow=settings.fpsmon.yellow
			local green=settings.fpsmon.green
			if fps< yellow then
				r=1
				g=math.max(0,fps-red)/(yellow-red)
			else
				g=1
				r=math.max(0,green-fps)/(green-yellow)
			end
			fps_info:SetColor(r,g,0)
		end
	end
	if last>1 and settings.hpmon.active==true then
		local health=UnitHealth("player")
		local maxhealth=UnitMaxHealth("player")
		local percent=100*health/maxhealth
		if health<hpmon.last_hp then
			if percent<settings.hpmon.percent then
				if timer-hpmon.last_alarm>15 then Zifnabs:hud(settings.hpmon,Zifnabs.LANG.Buffmon_HP_WARN..health.."!")	end
				hpmon.last_alarm=timer
			end
		elseif percent>settings.hpmon.percent+10 then
			hpmon.last_alarm=0
		end
		hpmon.last_hp=health
	end
	if last>1 and settings.buffmon.active==true then
		local mintime=settings.buffmon.time
		for buf=1,20,1 do
			local bufname=UnitBuff("player",buf)
			if bufname then
				local remain=UnitBuffLeftTime("player",buf)
				if remain==nil then remain=0 end -- endlose Buffs wie REITEN nicht monitoren
				if remain>mintime then
					if remain>30 then monitored_buff[bufname]=0 end -- Neuer Alarm für diesen Buf möglich
				else
					if monitored_buff[bufname] then
						if timer-monitored_buff[bufname]>30 then
							monitored_buff[bufname]=timer
							Zifnabs:hud(settings.buffmon,bufname.." <"..mintime.."s")
						end
					end
				end
			end
		end
	end
end

function Zifnabs_Buffmon:reload_settings()
	settings=Zifnabs:init_settings(default_settings)
	if settings.fpsmon.active then fps_frame:Show() else fps_frame:Hide() end
end
